blob: e6e2d9e5ff48785d5415f6724a76cadf82961c2b [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
Masahiro Yamada3ec8a5b2020-07-02 04:29:36 +090033LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020037# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41 if [ "${quiet}" != "silent_" ]; then
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070042 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020043 fi
44}
45
46# Link of vmlinux.o used for section mismatch analysis
47# ${1} output file
48modpost_link()
49{
Stephen Rothwella5967db2016-08-24 22:29:19 +100050 local objects
51
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100052 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090053 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100054 --no-whole-archive \
55 --start-group \
56 ${KBUILD_VMLINUX_LIBS} \
57 --end-group"
58
Masahiro Yamadad503ac52018-08-24 08:20:39 +090059 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020060}
61
Peter Zijlstra6804c1a2020-03-18 13:33:54 +010062objtool_link()
63{
64 local objtoolopt;
65
66 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
67 objtoolopt="check"
68 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
69 objtoolopt="${objtoolopt} --no-fp"
70 fi
71 if [ -n "${CONFIG_GCOV_KERNEL}" ]; then
72 objtoolopt="${objtoolopt} --no-unreachable"
73 fi
74 if [ -n "${CONFIG_RETPOLINE}" ]; then
75 objtoolopt="${objtoolopt} --retpoline"
76 fi
77 if [ -n "${CONFIG_X86_SMAP}" ]; then
78 objtoolopt="${objtoolopt} --uaccess"
79 fi
80 info OBJTOOL ${1}
81 tools/objtool/objtool ${objtoolopt} ${1}
82 fi
83}
84
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020085# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070086# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -070087# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020088vmlinux_link()
89{
90 local lds="${objtree}/${KBUILD_LDS}"
Andrii Nakryiko618916a2019-09-05 10:59:38 -070091 local output=${1}
Stephen Rothwella5967db2016-08-24 22:29:19 +100092 local objects
Kees Cookaf73d782020-03-03 18:18:34 -080093 local strip_debug
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020094
Linus Torvaldsd7b08272019-09-20 08:36:47 -070095 info LD ${output}
96
Andrii Nakryiko618916a2019-09-05 10:59:38 -070097 # skip output file argument
98 shift
99
Kees Cookaf73d782020-03-03 18:18:34 -0800100 # The kallsyms linking does not need debug symbols included.
101 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
102 strip_debug=-Wl,--strip-debug
103 fi
104
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200105 if [ "${SRCARCH}" != "um" ]; then
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000106 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +0900107 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000108 --no-whole-archive \
109 --start-group \
110 ${KBUILD_VMLINUX_LIBS} \
111 --end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700112 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000113
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700114 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800115 ${strip_debug#-Wl,} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700116 -o ${output} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000117 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200118 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000119 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +0900120 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000121 -Wl,--no-whole-archive \
122 -Wl,--start-group \
123 ${KBUILD_VMLINUX_LIBS} \
124 -Wl,--end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700125 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000126
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700127 ${CC} ${CFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800128 ${strip_debug} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700129 -o ${output} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000130 -Wl,-T,${lds} \
131 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000132 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200133 rm -f linux
134 fi
135}
136
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700137# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700138# ${1} - vmlinux image
139# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700140gen_btf()
141{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700142 local pahole_ver
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700143
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700144 if ! [ -x "$(command -v ${PAHOLE})" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000145 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700146 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700147 fi
148
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700149 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
Lorenz Bauer21a85bd2020-06-08 10:42:57 +0100150 if [ "${pahole_ver}" -lt "116" ]; then
151 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700152 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700153 fi
154
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700155 vmlinux_link ${1}
Kees Cookaf73d782020-03-03 18:18:34 -0800156
157 info "BTF" ${2}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700158 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700159
Fangrui Song90ceddc2020-03-18 15:27:46 -0700160 # Create ${2} which contains just .BTF section but no symbols. Add
161 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
162 # deletes all symbols including __start_BTF and __stop_BTF, which will
163 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
164 # objcopy warnings: "empty loadable segment detected at ..."
165 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
166 --strip-all ${1} ${2} 2>/dev/null
167 # Change e_type to ET_REL so that it can be used to link final vmlinux.
168 # Unlike GNU ld, lld does not allow an ET_EXEC input.
169 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700170}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200171
172# Create ${2} .o file with all symbols from the ${1} object file
173kallsyms()
174{
175 info KSYM ${2}
176 local kallsymopt;
177
178 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100179 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200180 fi
181
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700182 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030183 kallsymopt="${kallsymopt} --absolute-percpu"
184 fi
185
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700186 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
187 kallsymopt="${kallsymopt} --base-relative"
188 fi
189
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200190 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
191 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200192
Ard Biesheuvela0439342016-02-05 11:25:05 +0100193 local afile="`basename ${2} .o`.S"
194
195 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
196 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200197}
198
Kees Cook8959e392019-08-13 08:15:32 -0700199# Perform one step in kallsyms generation, including temporary linking of
200# vmlinux.
201kallsyms_step()
202{
203 kallsymso_prev=${kallsymso}
Kees Cookaf73d782020-03-03 18:18:34 -0800204 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
205 kallsymso=${kallsyms_vmlinux}.o
Kees Cook8959e392019-08-13 08:15:32 -0700206
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700207 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Kees Cook8959e392019-08-13 08:15:32 -0700208 kallsyms ${kallsyms_vmlinux} ${kallsymso}
209}
210
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200211# Create map file with all symbols from ${1}
212# See mksymap for additional details
213mksysmap()
214{
215 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
216}
217
Shile Zhang10916702019-12-04 08:46:31 +0800218sorttable()
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700219{
Shile Zhang10916702019-12-04 08:46:31 +0800220 ${objtree}/scripts/sorttable ${1}
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700221}
222
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200223# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200224cleanup()
225{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700226 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200227 rm -f .tmp_System.map
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200228 rm -f .tmp_vmlinux*
229 rm -f System.map
230 rm -f vmlinux
231 rm -f vmlinux.o
232}
233
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000234on_exit()
235{
236 if [ $? -ne 0 ]; then
237 cleanup
238 fi
239}
240trap on_exit EXIT
241
242on_signals()
243{
244 exit 1
245}
246trap on_signals HUP INT QUIT TERM
247
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200248# Use "make V=1" to debug this script
249case "${KBUILD_VERBOSE}" in
250*1*)
251 set -x
252 ;;
253esac
254
255if [ "$1" = "clean" ]; then
256 cleanup
257 exit 0
258fi
259
260# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900261. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200262
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200263# Update version
264info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900265if [ -r .version ]; then
266 VERSION=$(expr 0$(cat .version) + 1)
267 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200268else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900269 rm -f .version
270 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200271fi;
272
273# final build of init/
Masahiro Yamada083bc0e2020-02-11 05:06:34 +0900274${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200275
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100276#link vmlinux.o
277info LD vmlinux.o
278modpost_link vmlinux.o
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100279objtool_link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100280
281# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900282${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100283
Alexey Gladkov898490c2019-04-29 18:11:14 +0200284info MODINFO modules.builtin.modinfo
285${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
Masahiro Yamada8b41fc42019-12-19 17:33:29 +0900286info GEN modules.builtin
287# The second line aids cases where multiple modules share the same object.
288tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
289 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
Alexey Gladkov898490c2019-04-29 18:11:14 +0200290
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700291btf_vmlinux_bin_o=""
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700292if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
Kees Cookaf73d782020-03-03 18:18:34 -0800293 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
294 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800295 echo >&2 "Failed to generate BTF for vmlinux"
296 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
297 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700298 fi
299fi
300
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200301kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700302kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200303kallsyms_vmlinux=""
304if [ -n "${CONFIG_KALLSYMS}" ]; then
305
306 # kallsyms support
307 # Generate section listing all symbols and add it into vmlinux
308 # It's a three step process:
309 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
310 # but __kallsyms is empty.
311 # Running kallsyms on that gives us .tmp_kallsyms1.o with
312 # the right size
313 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
314 # the right size, but due to the added section, some
315 # addresses have shifted.
316 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100317 # 3) That link may have expanded the kernel image enough that
318 # more linker branch stubs / trampolines had to be added, which
319 # introduces new names, which further expands kallsyms. Do another
320 # pass if that is the case. In theory it's possible this results
321 # in even more stubs, but unlikely.
322 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
323 # other bugs.
324 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200325 #
326 # a) Verify that the System.map from vmlinux matches the map from
327 # ${kallsymso}.
328
Kees Cook8959e392019-08-13 08:15:32 -0700329 kallsyms_step 1
330 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200331
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100332 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700333 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
334 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100335
336 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700337 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200338 fi
339fi
340
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700341vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700342
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200343# fill in BTF IDs
344if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
345info BTFIDS vmlinux
346${RESOLVE_BTFIDS} vmlinux
347fi
348
Shile Zhang10916702019-12-04 08:46:31 +0800349if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
350 info SORTTAB vmlinux
Shile Zhangf14bf6a2019-12-04 08:46:33 +0800351 if ! sorttable vmlinux; then
352 echo >&2 Failed to sort kernel tables
353 exit 1
354 fi
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700355fi
356
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200357info SYSMAP System.map
358mksysmap vmlinux System.map
359
360# step a (see comment above)
361if [ -n "${CONFIG_KALLSYMS}" ]; then
362 mksysmap ${kallsyms_vmlinux} .tmp_System.map
363
364 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200365 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200366 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200367 exit 1
368 fi
369fi